# Faça um algoritmo que dado uma lista ordenada e um elemento indica onde
# inserir esse elemento na lista para mantê-la ordenada. Se o elemento já
# estiver na lista, você deve inseri-lo de forma a ser o primeiro do bloco
# repetido.
def busca_menor(lista, x):
    e = 0
    d = len(lista) - 1
    while e <= d:
        m = (e + d) // 2
        if lista[m] >= x:
            d = m - 1
        else:
            e = m + 1
    return e


# Use o algoritmo anterior para implementar uma busca em uma lista ordenada
def busca(lista, x):
    indice = busca_menor(lista, x)
    if lista[indice] == x:
        return indice
    return None


# Repita o primeiro exercício mas de forma que o elemento é o último do bloco
# repetido.
def busca_maior(lista, x):
    e = 0
    d = len(lista) - 1
    while e <= d:
        m = (e + d) // 2
        if lista[m] > x:
            d = m - 1
        else:
            e = m + 1
    return e


# Faça um algoritmo que dado uma lista ordenada e um elemento, encontra o
# intervalo que contém todos os elementos iguais a ele na lista.
def busca_intervalo(lista, x):
    menor = busca_menor(lista, x)
    maior = busca_maior(lista, x)
    return (menor, maior - 1)
